/*;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;  Copyright (c) 1995-1998, ADLink Technology Inc.  All rights reserved.  ;;
;;                                                                         ;;
;;      File Name   :   DO_DEMO1.C                                         ;;
;;      Purpose     :   Demo program of PCI-7434 digital output            ;;
;;      Date        :   4/28/1998                                          ;;
;;      Revision    :   1.00                                               ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;*/
#include <conio.h>
#include <stdio.h>
#include <stdlib.h>
#include <dos.h>
#include "std.h"
#include "video.h"
#include "key.h"
#include "acl_pci.H"
#include "aclerr.H"

#define ACL_TitleColor      (WHITE | bgcolor(GREEN))
#define ACL_TextColor       (WHITE | bgcolor(BLUE))
#define ACL_BkColor         (BLUE | bgcolor(BLUE))
#define ACL_MsgColor        (RED|INVERSE)
#define ACL_ProgColor       (WHITE | bgcolor(BROWN))


U8  *acl_Title = "****** PCI-7434 DO DEMO (Single) ******";
U8  *acl_Copyright="Copyright (c) 1995-1998, ADLink Technology Inc.  All rights reserved.";

/*----------------------------------------------------------------------*/

void showMessage(std_UByte *msg)
{
    video_ClearBox(24, 0, 24, 79, INVERSE);
    video_CenterPutStr(24, msg, ACL_MsgColor);
}
/*----------------------------------------------------------------------*/

void main( void )
{
    I16     i, j, err, row, col, key;
    U32     hiData=0x000, loData=0x800;
    char    tmpBuf[80];
    U16     existCards, curCardNo;
    PCI_INFO        info;
        U32     bn;

    /*---------- PCI-7434 initial ------------------------------------------*/
    err = _7434_Initial(&existCards, &info);
    if(err != ERR_NoError) {
        printf("PCI BIOS does not exist\n");
        exit(1);
    }
    if(existCards == 0) {
        printf("PCI-7434 does not exist\n");
        exit(1);
    }
    /*----------------------------------------------------------------------*/
    video_Initial();
    video_CursorOff();
    video_Box(VIDEO_SINGLE, 0, 0,  4, 79, ACL_TitleColor);
    video_Box(VIDEO_DOUBLE, 5, 0, 23, 79, ACL_TextColor);
    video_ClearBox(24, 0, 24, 79, INVERSE | BLUE);
    video_CenterPutStr(1, acl_Title, ACL_TitleColor);
    video_CenterPutStr(3, acl_Copyright, ACL_TitleColor);
    showMessage(">>> Press any key to change DO value, <Esc> to quit <<<");
    row = 10;
    col = 20;
    video_PutStr(row-2,  col, "PCI-7434 output: ", ACL_TextColor);

    curCardNo = PCI_CARD1;
        _7434_Software_Reset(curCardNo);

    _7434_DO_HiDW( curCardNo , hiData ); //MSB DO for PCI-7434
        sprintf(tmpBuf,"The MSB Double Word of DO Data = %08lX", hiData);
    video_PutStr(row, col, tmpBuf, INVERSE);

        _7434_DO_LoDW( curCardNo , loData ); //LSB DO for PCI-7434
        sprintf(tmpBuf,"The LSB Double Word of DO Data = %08lX", loData);
    video_PutStr(row+2, col, tmpBuf, INVERSE);

    key = !KEY_ESC;
    do {
         if(key_Hit()) {
            key = key_Get();
            loData++;
                hiData++;
            if(key == KEY_ESC) {
                        loData = 0;
                        hiData = 0;
                }
            sprintf(tmpBuf, "The MSB Double Word of DO Data = %08lX", hiData);
            _7434_DO_HiDW(curCardNo, hiData);
            video_PutStr(row, col, tmpBuf, INVERSE);
            sprintf(tmpBuf, "The LSB Double Word of DO Data = %08lX", loData);
            _7434_DO_LoDW(curCardNo, loData);
            video_PutStr(row+2, col, tmpBuf, INVERSE);
         }
    } while(key != KEY_ESC);
    video_CursorOn();
    video_ClearBox(24, 0, 24, 79, NORMAL);
}
